SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #Content
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!Content methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 22:01'!
isEmpty 
self subclassResponsibility.! !

Content subclass: #XXX
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!XXX methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 21:29'!
initialize! !

!XXX methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 21:00'!
isEmpty 
^true.! !

!XXX methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 21:57'!
push: anElement 
content:= YYY new push: anElement.! !

Content subclass: #YYY
	instanceVariableNames: 'elements stackpointer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!YYY methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 20:58'!
initialize
	elements := OrderedCollection new.
	stackpointer := 1.! !

!YYY methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 21:31'!
isEmpty 
^false.! !

!YYY methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 20:59'!
pop
        stackpointer := stackpointer -1.
		^elements at: stackpointer .! !

!YYY methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 20:59'!
push: anElement  
	elements add: anElement.
	stackpointer:= stackpointer+1.! !

!YYY methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 20:59'!
size
	^stackpointer - 1! !

!YYY methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 21:00'!
top 
^elements at: stackpointer - 1.! !

Object subclass: #OOStack
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 21:55'!
gimme
^content.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 22:02'!
initialize
	content:= XXX new.
	! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 22:01'!
isEmpty
	
	^content isEmpty .! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 21:47'!
pop
	self subclassResponsibility.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 21:47'!
push: anElement  
	self subclassResponsibility.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 21:47'!
size
	self subclassResponsibility.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/6/2013 21:47'!
top
	self subclassResponsibility.! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test09CanNotPopWhenThereAreNoObjectsInTheStackAndTheStackHadObjects

	| stack  |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test10CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
